/****************************************************/
/* bmp2picdat                                       */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN	255
#define	BUFNUM	160*200

int main(int argc, char **argv)
{
	char	infile[S_LEN],outfile[S_LEN];
	FILE	*infp, *outfp;
	unsigned char	dat[BUFNUM];
	unsigned char	r0,r1;
	unsigned char	d0,d1,d2,d3;
	int		c,num,i,j;
	int		width,height;

	if (argc != 4) {
		fprintf(stderr, "Usage: bmp2picdat width height filename\n");
		exit(1);
	}

/* open files */
	strncpy(infile ,argv[3],200);
	strncat(infile ,".bmp",5);
	strncpy(outfile,argv[3],200);
	strncat(outfile,".bin",5);

	if ((infp = fopen(infile, "rb")) == NULL) {
		perror(infile);
		exit(1);
	}

	if ((outfp = fopen(outfile, "wb")) == NULL) {
		perror(outfile);
		exit(1);
	}

	width  = atoi(argv[1]);
	height = atoi(argv[2]);

/* BMP header */
	for (i = 0;i < 118;i ++) {
		fgetc(infp);
	}

/* read and store BMP data */
	num = 0;
	while ((c = fgetc(infp)) != EOF) {
		dat[num] = (unsigned char)c;
		num ++;
		if (num > BUFNUM) {
			printf("buffer overflow\n");
			exit(1);
		}
	}

/* plane #0 */
	for (i = height-1;i >= 0;i --) {
		for (j = 0;j < width/2;j += 2) {
			r0 = dat[i*width/2+j+0];
			r1 = dat[i*width/2+j+1];
			d0 = ((r0 & 0x30) << 2);	/* b7,6 */
			d1 = ((r0 & 0x03) << 4);	/* b5,4 */
			d2 = ((r1 & 0x30) >> 2);	/* b3,4 */
			d3 =  (r1 & 0x03);			/* b1,0 */
			fputc((d0|d1|d2|d3),outfp);
		}
	}

/* plane #1 */
	for (i = height-1;i >= 0;i --) {
		for (j = 0;j < width/2;j += 2) {
			r0 = dat[i*width/2+j+0];
			r1 = dat[i*width/2+j+1];
			d0 =  (r0 & 0xc0);			/* b7,6 */
			d1 = ((r0 & 0x0c) << 2);	/* b5,4 */
			d2 = ((r1 & 0xc0) >> 4);	/* b3,2 */
			d3 = ((r1 & 0x0c) >> 2);	/* b1,0 */
			fputc((d0|d1|d2|d3),outfp);
		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}
